#include "emmix.h"
void intradist_(double *y, int *pn, int *pp, int *pg, int * clust,
double * sigma, double * tau, double * dist, double *dist2, int * pinfo)
{
int n = * pn, p = *pp, g = * pg;
double one =  1.0,minus = -1.0, zero = 0.0;
int incx=1,incy=1;
char trans[]="N";
double sigm[p*p],inv[p*p],wy[p],wx[p],wd[p]; 
double coco,temp,sum,tmp,sss;
int i,j,k,count,save[p];
double temp2,sum2,tttt,tmp2,sss2;
temp = zero;sum  = zero;
temp2 = zero;sum2  = zero;
for(k=0;k<g;k++) { 
tmp = zero;sss = zero;
tmp2 = zero;sss2 = zero;
for(i=0;i<p;i++) 
	for(j=0;j<p;j++) 
		sigm[j*p+i]=sigma[k*p*p+j*p+i];
inverse4_(sigm,inv,&p,&count,save);
for(j =0;j < n;j++) { // j th point
if(clust[j] != (k+1) ) continue;
F77_NAME(dcopy)( &p, y+j, &n, wy, &incy);
for(i=j+1;i < n;i++) { //i th point
if(clust[i] != (k+1)) continue;
F77_NAME(dcopy)( &p, y+i, &n, wx, &incy);
F77_NAME(daxpy)( &p, &minus, wy, &incy, wx, &incx);
F77_NAME(dgemv)(trans, &p, &p, &one, inv, &p, wx, &incx, &zero, wd, &incy);
coco = (tau[k*n+i]*tau[k*n+j] );
tttt = ddot_(&p, wd, &incx, wd,&incy);
tmp += (tttt* coco) ;
sss  += coco;
tmp2 += tttt;
sss2 += one;
}  
}  
temp  +=tmp;
sum   +=sss;
if(sss >= 1.0) 
dist[k]=tmp/sss; 
else
dist[k]=zero;
temp2  +=tmp2;
sum2   +=sss2;
if(sss2 >= 1.0) 
dist2[k]=tmp2/sss2;
else
dist2[k]=zero;
}  
if(sum >= 1.0) 
dist[g]=temp/sum; 
else
dist[g]=zero;
if(sum2 >= 1.0) 
dist2[g]=temp2/sum2; 
else
dist2[g]=zero;
return;
}
void interdist_(double *y, int *pn, int *pp, int *pg, int *clust,
double * sigma, double * tau, double * dist, double *dist2, int * pinfo)
{
int n = * pn,  p = * pp, g = *pg;
double one =  1.0,minus = -1.0, zero = 0.0;
int  incx=1,incy=1;
char trans[]="N";
double sigm[p*p],wy[p],wx[p],wd[p],inv[p*p]; 
double coco,temp,sum, tmp,sss;
int i,j,k,r,count,save[p];
double temp2,sum2,tttt,tmp2,sss2;
if(g == 1) {
	dist[1]=zero;dist2[1]=zero;
	return;}
temp = zero;
sum  = zero;
temp2 = zero;
sum2  = zero;
for(k=0;k<g;k++) { 
	dist[k*g+k]=zero;
	dist2[k*g+k]=zero;
for(r=k+1;r<g;r++) { 
tmp = zero;
sss = zero;
tmp2 = zero;
sss2 = zero;
for(i=0;i<p;i++) 
	for(j=0;j<p;j++)
		sigm[j*p+i]=(sigma[k*p*p+j*p+i]+sigma[r*p*p+j*p+i]);
inverse4_(sigm,inv,&p,&count,save);
if(*pinfo != 0)
	 return;
for(j =0;j < n;j++) { // j th point
if(clust[j] != (k+1)) continue;
F77_NAME(dcopy)( &p, y+j, &n, wy, &incy);
for(i=0;i < n;i++) { //i th point
if(clust[i] != (r+1)) continue;
F77_NAME(dcopy)( &p, y+i, &n, wx, &incx);
F77_NAME(daxpy)( &p, &minus, wy, &incy, wx, &incx);
F77_NAME(dgemv)(trans, &p, &p, &one, inv, &p, wx, &incx, &zero, wd, &incy);
coco = (tau[k*n+j]*tau[r*n+i] );
tttt = ddot_(&p, wd, &incx, wd,&incy);
tmp += (tttt* coco) ;
sss  += coco;
tmp2 += tttt;
sss2 += one;
}  
}  
if(sss >= 1.0) {
dist[r*g+k] = tmp/sss;
dist[k*g+r] = tmp/sss;
}
else
{
dist[r*g+k] = zero;
dist[k*g+r] = zero;
}
if(sss2 >=1.0) {
dist2[r*g+k] = tmp2/sss2;
dist2[k*g+r] = tmp2/sss2;
}
else
{
dist2[r*g+k] = zero;
dist2[k*g+r] = zero;
}
temp += tmp;
sum  += sss;
temp2 += tmp2;
sum2  += sss2;
} 
}  
if(sum >= 1.0) 
dist[g*g] = temp/sum; 
else
dist[g*g]=zero;
if(sum2 >= 1.0) 
dist2[g*g] = temp2/sum2; 
else
dist2[g*g]=zero;
return;
}
void mahalonobis_(int *pp, int *pg, double * mu, 
double * sigma, double * dist, int * pinfo)
{
int p = *pp, g = *pg;
int count,save[p];
double one =  1.0,minus = -1.0, zero = 0.0;
int  incx=1,incy=1;
char trans[]="N";
double sigm[p*p],wy[p],wx[p],inv[p*p]; 
int i,j,k,r;
pinfo[0]=0;
for(k=0;k<g;k++) { 
dist[k*g+k]= zero;
for(r=k+1;r<g;r++) { 
for(i=0;i<p;i++) 
	for(j=i;j<p;j++) 
		sigm[j*p+i]=(sigma[k*p*p+j*p+i]+sigma[r*p*p+j*p+i]);
inverse4_(sigm,inv,&p,&count,save);
F77_NAME(dcopy)( &p, mu+k*p, &incx, wy, &incy);
F77_NAME(dcopy)( &p, mu+r*p, &incx, wx, &incy);
F77_NAME(daxpy)( &p, &minus, wy, &incx, wx, &incy);
F77_NAME(dgemv)(trans, &p, &p, &one, inv, &p, wx, &incx, &zero, wy, &incy);
dist[r*g+k] = F77_NAME(ddot)(&p, wy, &incx, wy,&incy);
dist[k*g+r] = dist[r*g+k];
}  
}  
return;
}

