#include <R.h>
#include <Rmath.h>
#include <R_ext/BLAS.h>
#include <R_ext/Lapack.h>
#include <R_ext/Applic.h>
typedef struct _EMMIX_{
double *pro;
double *mu;
double *sigma;
double *dof;
double *delta;
} EMMIX, *PEMMIX;
void initfit_( double *y, int *pn, int *pp,int *pg, int *pncov,int *pdist, 
double * pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elnv, double *ez1v,double *ez2v,
double *loglik, int *clust, int *pinfo, int *method, int *maxloop);
void emmixfit1(double *y, int *pn, int *pp,int *pg,  int *pncov,int *pdist,
double *pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elnv, double *ez1v,double *ez2v,
double *loglik, double *lk, double *aic, double *bic,
int *clust, 
int *pinfo,  int *itmax, double *epsilon, int *method);
void emmixfit2(double *y, int *pn, int *pp,int *pg, int *pncov, int *pdist, 
double *pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elnv, double *ez1v,double *ez2v,
double *loglik, double *lk, double *aic, double *bic,
int *clust, 
int *pinfo,  int *itmax, double *epsilon, int *method);
void emmvn_( double *y, int *pn, int *pp,int *pg,int *pncov,
double *pro, double *mu, double * sigma,
double *tau, double *loglik, double *lk,  
int *pinfo,int *itmax, double *epsilon);
void emmvt_( double *y, int *pn, int *pp,int *pg,int *pncov,
double * pro, double *mu, double * sigma, double *dof,
double *tau,double *xuu,double *loglik, double *lk, 
int *pinfo,int *itmax, double *epsilon);
void emmsn_( double *y, int *pn, int *pp,int *pg, int *pncov,
double *pro, double *mu, double * sigma, double *delta,
double *tau, double *ev, double *vv, double *loglik, double *lk, 
int *pinfo, int *itmax,  double *epsilon);
void emmst_(double *y, int *pn, int *pp,int *pg, int *pncov,
double *pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elogv, double *ez1v,double *ez2v,
double *loglik, double *lk, //loglikelihood values
int *pinfo,int *itmax, double *epsilon);
void initmvn_( double *y, int *pn, int *pp,int *pg,int *pncov, 
double *pro, double *mu, double *sigma, 
double *tau,double *loglik, int *clust,int *pinfo, int *);
void initmvt_( double *y, int *pn, int *pp,int *pg,int *pncov, 
double *pro, double *mu, double *sigma, double *dof,
double *tau, double *xuu,double *loglik, int *clust,int *pinfo, int *);
void initmsn_(double *y, int *pn, int *pp,int *pg, int *pncov,
double *pro, double *mu, double *sigma, double *delta,
double *tau, double *ev, double *vv, 
double *loglik,int *clust,int *pinfo, int *);
void initmst_(double *y, int *pn, int *pp,int *pg, int *pncov,
double *pro, double *mu, double *sigma, double *dof, double *delta,
double *tau, double *ev, double *elogv, double *ez1v,double *ez2v,
double *loglik,int *clust,int *pinfo, int *);
void estepmvn_(double *y, int *pn, int *pp, int *pg,
double *pro, double * mu, double * sigma, 
double * tau, double * sumtau,double * loglik,int *pinfo);
void estepmvt_(double *y, int *pn, int *pp, int *pg,
double *pro, double *mu, double *sigma, double *dof,
double *tau, double *sumtau,double *xuu,double * sumxuu,double *sumxuuln, 
double * loglik,int * pinfo);
void F77_NAME(estepmsn)(double *y, int *pn, int *pp,int *pg,
double *pro, double *mu, double * sigma,  double *delta,
double *tau, double *sumtau, double *ev, double *vv, 
double *loglik, int *pinfo);
void F77_NAME(estepmst)(double *y, int *pn, int *pp,int *pg,
double * pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elogv, double *ez1v,double *ez2v,
double *sumtau, double *sumvt, double *sumzt,double *sumlogv,
double *loglik, int *pinfo, int *method);
void F77_SUB(mstepmvn)(double *y,int *pn, int *pp, int *pg,int *pncov,
double *tau, double *sumtau, double *mu, double *sigma);
void F77_SUB(mstepmvt)(double *y,int *pn, int *pp, int *pg,int *pncov,
double *tau, double *sumtau, double *xuu,double *sumxuu, double *sumxuuln,
double *mu, double *sigma, double *dof);
void F77_NAME(mstepmsn)(double *y, int *pn, int *pp,int *pg, int *pncov,
double *tau, double *sumtau, double *ev, double *vv,
double *mu, double * sigma, double *delta);
void F77_NAME(mstepmst)(double *y, int *pn, int *pp,int *pg, int *pncov,
double *tau, double *ev, double *ez1v,double *ez2v,
double *sumtau, double *sumvt, double *sumzt,
double *mu, double * sigma, double *delta);
void ddmix(double *x, int *pn, int *pp, int *pg,int *pdist,
double *mu, double *sigma, double *dof,double *delta,
double *den, int *pinfo);
void denmvn(double *x, int *pn, int *pp, int *pg,
double * mu, double * sigma,
double *den, int *pinfo);
void denmvt(double *x, int *pn, int *pp, int *pg,
double *mu, double *sigma, double *dof,
double *den, int *pinfo);
void F77_SUB(denmvt2)(double *y, int *pn, int *pp, int *pg,
double * mu, double * sigma, double *dof,
double *den,double *xuu, int *pinfo);
void F77_NAME(denmst)(double *x, int *pn, int *pp, int *pg,
double *mu, double *sigma, double *dof,double *delta,
double *den, int *pinfo);
void F77_NAME(denmst2)(double *y, int *pn, int *pp, int *pg,
double * mu, double * sigma, double *dof,double *delta,
double *tau,double *ev,double *elogv,double *,double *,
int *error,int *method);
void F77_NAME(denmsn)(double *x, int *pn, int *pp, int *pg,
double * mu, double * sigma, double *delta, 
double *den, int *pinfo);
void F77_NAME(denmsn2)(double *y, int *pn, int *pp, int *pg,
double * mu, double * sigma, double *delta,
double *tau,double *ev,double *vv,int *perror);
void F77_NAME(predmixdamsn)(double *x,int *n,int *p,int *g, 
double *pro,double *mu,double *Sigma,double *delta,
double *tau,int *info);
void F77_NAME(predmixdamst)(double *x,int *n,int *p,int *g, 
double *pro,double *mu,double *Sigma,double *dof, double *delta,
double *tau,int *info);
void F77_NAME(emskewpred)(double *x,int *n,int *p,int *g,int *dist, 
double *pro,double *mu,double *sigma,double *dof, double *delta,
double *tau,int *, int *info);
void F77_NAME(emskewda)(double *x,int *n,int *p,int *g,int *ncov,int *dist, 
double *pro,double *mu,double *sigma,double *dof, double *delta,
double *tau,double *ev,double *elogv,double *,double *,
double *loglik,double *lk,int *clust,int *itmax,double *epsilon,int *error);
void F77_NAME(emmvnda)(double *x,int *n,int *p,int *g,int *ncov,
double *pro,double *mu,double *sigma,
double *tau,int *clust,int *error);
void F77_NAME(emmvtda)(double *x,int *n,int *p,int *g,int *ncov,
double *pro,double *mu,double *sigma,double *dof, 
double *tau,double *xuu,
double *loglik,double *lk,int *clust,int *itmax,double *epsilon,int *error);
void F77_NAME(emmsnda)(double *x,int *n,int *p,int *g,int *ncov,
double *pro,double *mu,double *sigma,double *delta,
double *tau,double *,double *,
double *loglik,double *lk,int *clust,int *itmax,double *epsilon,int *error);
void F77_NAME(emmstda)(double *x,int *n,int *p,int *g,int *ncov,
double *pro,double *mu,double *sigma,double *dof, double *delta,
double *tau,double *,double *,double *,double *,
double *loglik,double *lk,int *clust,int *itmax,double *epsilon,int *error);
void F77_NAME(emskewmod)(int *dist,int *p,int *g,double *step,
double *mu,double *Sigma,double *dof,double *delta,
double *emean,double *esigma,double *modpts,int *info);
void F77_NAME(mixmodmsn)(int *p,int *g,double *step,
double *mu,double *Sigma,          double *delta,
double *emean,double *esigma,double *modpts,int *info);
void F77_NAME(mixmodmst)(int *p,int *g,double *step,
double *mu,double *Sigma,double *dof,double *delta,
double *emean,double *esigma,double *modpts,int *info);
void Zeroin_(double *ax,double *bx,double (*f)(double x, void *info), 
void *info,double *Tol,int *Maxit,double *root);        
typedef struct _MINFO_ {double stau;double sxuu;
} MINFO,*PMINFO;
double Tequ(double dof,void *info);
void F77_SUB(getdof)(int *pn, int *pg, double *sumtau, double *sumxuuln, 
double *dof, double *bx);
void F77_SUB(tau2clust)(double * tau, int *pn, int* pg, int * clust);
void F77_SUB(getcov)(double *sigma,double *sumtau,int *n,int *p,int *g,int *ncov);
void F77_SUB(gettau)(double *tau,double *pro, double *loglik, 
int *pn, int*pg, int *pinfo);
void SingularityHandler(double *sigma, double * sigm,double *inv, 
int *pp, int *pcount, int * save,double eps);
void F77_SUB(inverse3)(double *sigma, double * inv, double * pdet, 
int *pp, int * pinfo,int *pcount, int * save);
void inverse4_(double *sigma, double * inv,
int *pp, int *pcount, int * save);
void absrng_(double * ,int* , double * , double * );
void nonzeromax_(double* v, int *p, double *vmax);
void myrevsort_(double *a, int *ib, int *pn);
double fnn(double y,double dof, double p, int k);
void F77_SUB(intsum)(double *pux, double *pdist, double *pdof, 
double *ret, int *pp, int *pL);
void F77_NAME(skew)(double *y,int *pn, int *pp,int *pg,
double *tau, double *sumtau,double *mu, double * sigma,double *delta);
double F77_SUB(mygammln)(double * x);
double F77_SUB(mvphit)(double *x, double *v);
double F77_SUB(mvphin)(double *x);
double F77_SUB(mydnorm)(double *x);
double F77_SUB(mydigamma)(double *x);
void intradist_(double *y, int *pn, int *pp, int *pg, int * clust,
double * sigma, double * tau, double * dist, double *dist2, int * pinfo);
void interdist_(double *y, int *pn, int *pp, int *pg, int *clust,
double * sigma, double * tau, double * dist, double *dist2, int * pinfo);
void mahalonobis_(int *pp, int *pg, double * mu, 
double * sigma, double * dist, int * pinfo);
void F77_NAME(denmst3)(double *y, int *pn, int *pp, int *pg,
double * pro,double * mu, double * sigma, double *dof,double *delta,
double *tau,double *ev,double *elogv,double *,double *,
double *ewy,double *loglik,
int *error,int *method);
/* the end of emmix.h */
