      subroutine estepmsn(x,n,p,G,pro,mu,sigma,delta,
     &tau,sumtau,ev,vv,loglik,error)
      implicit NONE
      integer            n, p, G, error
      double precision   loglik
      double precision   x(n,*), tau(n,  *  ),delta(p,*)
      double precision   mu(p,*), Sigma(p,p,*), pro(  *  )
      double precision   ev(n,*), vv(n,*),sumtau(*)
      integer            i, k
      double precision        zero, one, two
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      error  = 0
      call denmsn2(x,n,p,g,mu,sigma,delta,
     &tau,ev,vv,error)
      if(error .ne. 0) then
        error=22
        return
      endif
      loglik = zero
      call gettau(tau,pro,loglik,n,g,error)
      if(error .ne. 0) then
        error=23
        return
      endif
      do k=1,G
        sumtau(k)=zero
      end do
      do i=1,n
      do k=1,G
          sumtau(k)=sumtau(k)+tau(i,k)
      enddo
      end do
      do k=1,G
         pro(k)=sumtau(k)/dble(n)
      end do
      return
      end
      subroutine mstepmsn(y,n,p,ng,ncov,tau,sumtau,ev,vv,
     &mu,sigma,delta)
      implicit none
      integer n,p,ng,ncov
      double precision y(n,*), mu(p,*), sigma(p,p,*)
      double precision delta(p,*),tau(n,*),sumtau(*)
      double precision   ev(n,*), vv(n,*)
      double precision sum,tmp,sumev
      integer h,i,j,k
      double precision        zero, one, two
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      do h=1,ng
       do j=1,p
         sum=zero
         tmp=zero
         sumev=zero
         do i=1,n
           sum=sum+(y(i,j)- delta(j,h)*ev(i,h) ) * tau(i,h)
           tmp=tmp+(y(i,j)-mu(j,h))*ev(i,h)*tau(i,h)
           sumev=sumev+vv(i,h)*tau(i,h)
         enddo
          if(sumtau(h)  .lt. two) then
            mu(j,h) =zero
            delta(j,h)=zero
          else
            mu(j,h)=sum/sumtau(h)
            delta(j,h)=tmp/sumev
          endif
       enddo
      enddo
      do 1000 h=1,ng
        do 100 j=1,p
          do 100 i=1,J
            sigma(i,j,h)=zero
100     continue
        do 200 i=1,n
          do 200 k=1,p
            do 200 j=1,k
              sigma(j,k,h)=sigma(j,k,h)
     & +(y(i,j)-mu(j,h)  )*( y(i,k)-mu(k,h))*tau(i,h)
     & -(delta(j,h)*ev(i,h) )*( y(i,k)-mu(k,h))*tau(i,h)
     & -(delta(k,h)*ev(i,h) )*( y(i,j)-mu(j,h))*tau(i,h)
     & +delta(j,h)*delta(k,h)*vv(i,h)*tau(i,h)
200     continue
        do 300 J=1,p
          do 300 I=1,J
          if(sumtau(h) .lt. two) then
            sigma(i,j,h) =zero
          else
            sigma(I,J,h)=sigma(I,J,h)/sumtau(h)
          endif
          sigma(j,i,h)=sigma(i,j,h)
300     continue
1000  continue
      call getcov(sigma,sumtau,n,p,ng,ncov)
      return
      end
      double precision function dnbypn(x)
      implicit none
      integer maxpts
      double precision x,tmp,delta,abs
      double precision lower,upper,mydnorm,mvphin
      integer i
      maxpts = 10000
      if(x .gt. -37.0) then
        dnbypn=mydnorm(x)/mvphin(x)
        goto 100
      endif
      dnbypn = abs(x)
      if(maxpts .eq. 0) then
      lower=x-0.1
      upper=x
      delta=(upper-lower)/maxpts
      tmp=0.0
      do i=0,maxpts-1
         tmp=tmp+exp(-0.5*((lower+delta*i)*(lower+delta*i)-x*x))
      enddo
      dnbypn=dble(1)/(delta*tmp)
      endif
100   continue
      return
      end
